game:SetSplashScreen("resources\\loadingscreen.png")
console:SetMode(FTGLConsole.CONSOLE_TOP)

--player.position = Vector3f(34, 29, 44)
--player:LookAt(Vector3f(-5,0,5))

--player.position = Vector3f(0.94, 4.4, 41.5)
--player:LookAt(Vector3f(-3,2.5,0))

--player.position = Vector3f(-4.292, 1.68, 40.39)
--player:SetAngle(0.054, -0.0955)

--player.position = Vector3f(57, 32, 36.5)
--player:SetAngle(-0.2585, -5.202)

--player.position = Vector3f(48, 14.2, 41)
--player:SetAngle(-0.0141, -5.2708)

--player.position = Vector3f(40, 13, 57)
--player:SetAngle(0.0151, -5.647)

inPlane = false

function SetInPlane(newPlaneValue)
	if(inPlane == not newPlaneValue) then
		player:ToggleVehicle()
		if(inPlane) then
			-- Set outside
			player.inputShouldBeGrabbed = false
			player.mouselook = false
			player.canFly = true
	
			player.position = Vector3f(-22.4, 17.67, -79.12)
			player:SetAngle(-0.109, -2.856)
		else
			-- Set inside
			player.inputShouldBeGrabbed = true
			player.mouselook = true
			player.canFly = true
			player:SetAngle(-0.15, 0)
		end
		inPlane = newPlaneValue
	end
end


player.height = 1.68

player.canFly = true

player.mouseXSensitivity = 1.5
player.mouseYSensitivity = 1.5

player.walkSpeed = 0.5

player.bombExplosionRadius = 5;
player.bombExplosionDuration = 1;
--player.bombExplosionForce = 700000
--player.bombExplosionForce = 1000000
player.bombExplosionForce = 1200000

game.collisionsEnabled = true

game.gravity = Vector3f(0,-7.8,0)

--game.gravity = Vector3f(0,0,0)
--[[
-- THE DC-3
game:LoadMesh("dc3", "resources\\dc3.obj", "resources\\woodknots.jpg", Vector3f(0.115, 0.115, 0.115), Point3(30,7,20), true, 8, true)
game:FindObject("dc3").body.trackChunks = true
game:FindObject("dc3").body:Translate(Vector3f(0,0,-1000))
game:FindObject("dc3").body.fractureRotationTolerance = 0.35
game:FindObject("dc3").body.fractureDistanceTolerance = 0.15
game:FindObject("dc3").body.fractureGoalWeight = 0.5
game:FindObject("dc3").body.kRegionDamping = 0.9
game:FindObject("dc3").body:MultiplyMass(0.1)

plane:AssignBody(game:FindObject("dc3").body)
plane:AddLiftRegion(Vector3f(1/0.115,2/0.115,-1/0.115), Vector3f(17/0.115,4/0.115,5/0.115), 50, 10)
plane:AddLiftRegion(Vector3f(1/0.115,3.5/0.115,-12/0.115), Vector3f(5/0.115,5/0.115,-8/0.115), 30, 0)
plane:AddRudder(Vector3f(-1/0.115,4/0.115,-12/0.115), Vector3f(1/0.115,8/0.115,-8/0.115), 3)
plane:AddPropeller(Vector3f(3.2/0.115,2.8/0.115,8.0/0.115), "resources\\dc3prop.obj", Vector3f(0.115, 0.115, 0.115), 40, 110)
plane:AddPropeller(Vector3f(-3.2/0.115,2.8/0.115,8.0/0.115), "resources\\dc3prop.obj", Vector3f(0.115, 0.115, 0.115), 40, 110)

game:FindObject("dc3").body:SetMaterialVolumeFluidFriction(BoundingBox(Vector3f(-1000,0,-1000), Vector3f(1000,20,1000)), 0)
]]--

--[[
-- THE TOWER (CONCRETE)
if(not game.debug) then
	game:LoadMesh("tower", "resources\\tower.obj", "resources\\cement.jpg", Vector3f(0.13, 0.13, 0.13), Point3(10,23,10), true, 9, true)
else
	game:LoadMesh("tower", "resources\\tower.obj", "resources\\cement.jpg", Vector3f(0.13, 0.13, 0.13), Point3(3,7,3), true, 9, true)
end

game:FindObject("tower").body:Translate(Vector3f(0,0,-5))
game:LockBottom(game:FindObject("tower").body)
game:FindObject("tower").body.fractureRotationTolerance = 0.15
game:FindObject("tower").body.fractureDistanceTolerance = 0.45
--game:FindObject("tower").body.fractureGoalWeight = 0.7
game:FindObject("tower").body.kRegionDamping = 0.9

game:FindObject("tower").body:MultiplyMass(0.12)
]]--

--[[
if(not game.debug) then
-- THE TOWER (CONCRETE)
game:LoadMesh("tower", "resources\\tower.obj", "resources\\cement.jpg", Vector3f(0.13, 0.13, 0.13), Point3(10,30,10), true, 12, true)

game:FindObject("tower").body:Translate(Vector3f(0,0,-5))
game:LockBottom(game:FindObject("tower").body)
game:FindObject("tower").body.fractureRotationTolerance = 0.15
game:FindObject("tower").body.fractureDistanceTolerance = 0.45
--game:FindObject("tower").body.fractureGoalWeight = 0.7
game:FindObject("tower").body.kRegionDamping = 0.9

game:FindObject("tower").body:MultiplyMass(0.12)
end
]]--

--[[
if(not game.debug) then
-- THE TOWER (WOOD)
game:LoadMesh("tower", "resources\\tower.obj", "resources\\oldwood.jpg", Vector3f(0.13, 0.13, 0.13), Point3(10,30,10), true, 10, true)

game:FindObject("tower").body:Translate(Vector3f(0,0,-5))
game:LockBottom(game:FindObject("tower").body)
game:FindObject("tower").body.fractureRotationTolerance = 0.20
game:FindObject("tower").body.fractureDistanceTolerance = 0.45
game:FindObject("tower").body:MultiplyMass(0.12)
end
]]--

---[[
-- THE F4U Corsair
--game:LoadMesh("f4u", "resources\\f4u.obj", "resources\\woodknots.jpg", Vector3f(0.115, 0.115, 0.115), Point3(19,7,15), true, 8, true)
game:LoadMesh("f4u", "resources\\f4u.obj", "resources\\woodknots.jpg", Vector3f(0.115 * 0.6, 0.115 * 0.6, 0.115 * 0.6), Point3(13,6,12), true, 5, true)
game:FindObject("f4u").body.trackChunks = true
game:FindObject("f4u").body:Translate(Vector3f(0,16,-400))
game:FindObject("f4u").body.fractureRotationTolerance = 0.35
game:FindObject("f4u").body.fractureDistanceTolerance = 0.35
game:FindObject("f4u").body.fractureGoalWeight = 0.2
game:FindObject("f4u").body.kRegionDamping = 0.9
game:FindObject("f4u").body:MultiplyMass(1.5)

plane:AssignBody(game:FindObject("f4u").body)
plane:AddLiftRegion(Vector3f(8.7,13.05,2.61), Vector3f(69.6,23.49,34.8), 3.5, 0.5)
plane:AddLiftRegion(Vector3f(4.35,26.1,-47.85), Vector3f(24.36,34.8,-28.71), 0, 0)
plane:AddRudder(Vector3f(-4.35,26.1,-43.5), Vector3f(4.35,47.85,-21.75), 0.05)
plane:AddPropeller(Vector3f(0,22.87,48.087), "resources\\f4uprop.obj", Vector3f(0.115 * 0.6, 0.115 * 0.6, 0.115 * 0.6), 30, 80)
plane:AddFuselage(Vector3f(-4,-100,-20), Vector3f(4,50,25))
plane.airMass = 7
plane.drag = 0.9988

game:FindObject("f4u").body:SetMaterialVolumeFluidFriction(BoundingBox(Vector3f(-1000,0,-1000), Vector3f(1000,13,1000)), 0)
game:FindObject("f4u").body:SetMaterialVolumeFluidFriction(BoundingBox(Vector3f(-800,0,-6000), Vector3f(800,400,0)), 0)

game:FindObject("f4u").body:Rotate(Vector3f(1,0,0), -0.23)
game:FindObject("f4u").body:AddVelocity(Vector3f(0, 0, 80))
]]--

--[[
-- THE CUBE
game:LoadMesh("cube", "resources\\cube.obj", "resources\\cube.jpg", Vector3f(0.15, 0.15, 0.15), Point3(4,4,4), false, 1, false)

game:FindObject("cube").body:Translate(Vector3f(0,0,20))
--game:LockBottom(game:FindObject("cube").body)
game:FindObject("cube").body.fractureRotationTolerance = 0.25
game:FindObject("cube").body.fractureDistanceTolerance = 0.25
game:FindObject("cube").body.fractureGoalWeight = 0.4
game:FindObject("cube").body.kRegionDamping = 0.9
]]--



--[[
-- THE BILLBOARD
if(game.debug == false) then
game:LoadMesh("billboard", "resources\\billboard.obj", "resources\\oldwood.jpg", Vector3f(0.4, 0.4, 0.4), Point3(13,13,3), true, 3, true)

game:FindObject("billboard").body:Translate(Vector3f(0,0,500))
game:LockBottom(game:FindObject("billboard").body)
game:FindObject("billboard").body.fractureRotationTolerance = 0.1
game:FindObject("billboard").body.fractureDistanceTolerance = 0.35
game:FindObject("billboard").body.fractureGoalWeight = 0.5
--game:FindObject("billboard").body.kRegionDamping = 0.5

game:FindObject("billboard").body:MultiplyMass(0.055)
end
]]--

---[[

if(game.debug ==  false) then
-- THE SILO
game:LoadMesh("silo", "resources\\silo.obj", "resources\\oldwood.jpg", Vector3f(0.13 * 3 * 0.6, 0.15 * 3 * 0.6, 0.13 * 3 * 0.6), Point3(10,15,10), false, 5, true)
game:FindObject("silo").body:Translate(Vector3f(-15,0,-10))
game:LockBottom(game:FindObject("silo").body)
game:FindObject("silo").body.fractureRotationTolerance = 0.10
game:FindObject("silo").body.fractureDistanceTolerance = 0.20
game:FindObject("silo").body.fractureGoalWeight = 0.0
game:FindObject("silo").body.kRegionDamping = 0.8
game:FindObject("silo").body:MultiplyMass(0.05)

-- THE BARN
game:LoadMesh("barn", "resources\\barnflipped.obj", "resources\\oldwood.jpg", Vector3f(0.13 * 2 * 0.6, 0.15 * 2 * 0.6, 0.13 * 2 * 0.6), Point3(13,11,14), false, 5, true)
game:FindObject("barn").body:Translate(Vector3f(0,0,-10))
game:LockBottom(game:FindObject("barn").body)
game:FindObject("barn").body.fractureRotationTolerance = 0.10
game:FindObject("barn").body.fractureDistanceTolerance = 0.20
game:FindObject("barn").body.fractureGoalWeight = 0.0
game:FindObject("barn").body.kRegionDamping = 0.8
game:FindObject("barn").body:MultiplyMass(0.05)


--[[
-- THE SILO
game:LoadMesh("silo2", "resources\\silo.obj", "resources\\oldwood.jpg", Vector3f(0.13 * 2, 0.15 * 4, 0.13 * 2), Point3(7,24,7), false, 5, true)
game:FindObject("silo2").body:Translate(Vector3f(15,0,-10))
game:LockBottom(game:FindObject("silo2").body)
game:FindObject("silo2").body.fractureRotationTolerance = 0.10
game:FindObject("silo2").body.fractureDistanceTolerance = 0.10
game:FindObject("silo2").body.fractureGoalWeight = 0.0
game:FindObject("silo2").body.kRegionDamping = 0.8
game:FindObject("silo2").body:MultiplyMass(0.05)

-- THE SILO
game:LoadMesh("silo3", "resources\\silo.obj", "resources\\oldwood.jpg", Vector3f(0.13 * 2, 0.15 * 2, 0.13 * 2), Point3(7,12,7), false, 5, true)
game:FindObject("silo3").body:Translate(Vector3f(30,0,-10))
game:LockBottom(game:FindObject("silo3").body)
game:FindObject("silo3").body.fractureRotationTolerance = 0.10
game:FindObject("silo3").body.fractureDistanceTolerance = 0.10
game:FindObject("silo3").body.fractureGoalWeight = 0.0
game:FindObject("silo3").body.kRegionDamping = 0.8
game:FindObject("silo3").body:MultiplyMass(0.05)
]]--
end

]]--

function RenderHelp()
	graphics:RenderText(Color(1,1,1,1), Vector2f(50, 500 + 20), 18, "F1, F2: Switch demos")
	graphics:RenderText(Color(1,1,1,1), Vector2f(50, 500), 18, "R: Reset scene")
	graphics:RenderText(Color(1,1,1,1), Vector2f(50, 500 - 20), 18, "W,A,S,D: Fly plane")
	graphics:RenderText(Color(1,1,1,1), Vector2f(50, 500 - 20 - 20), 18, "F: Toggle view")
	graphics:RenderText(Color(1,1,1,1), Vector2f(50, 500 - 20 - 20 - 20), 18, "P: Pause")
	--graphics:RenderText(Color(1,1,1,1), Vector2f(50, 500 - 20 - 20 - 20 - 20), 18, "`: Console")
end

frames = 0
lastFrames = 0

weapon = 1		-- 1 = cannon, 2 = raygun, 3 = bombs

recording = false
screenshotNo = 0

function RenderPlane()
	if(weapon == 1) then
		player:PlotCannonPath()
	end

	if(recording) then
		graphics:SaveScreenshot("screenshots/ss" .. screenshotNo .. ".png")
		screenshotNo = screenshotNo + 1
	end

	---[[
	graphics:SetupOrtho()
	graphics:RenderTextCentered(Color(1,1,0,1), Vector2f(graphics.windowSize.x * 0.33, graphics.windowSize.y - 30), 24, "F1: Structure demo")
	graphics:RenderTextCentered(Color(1,0,0,1), Vector2f(graphics.windowSize.x * 0.66, graphics.windowSize.y - 30), 24, "F2: Vehicle demo")
	--graphics:RenderText(Color(1,1,0,1), Vector2f(graphics.windowSize.x * 0.80 - 130, 100), 24, "F3: Indoor demo")
	--graphics:RenderTextCentered(Color(1,1,0,1), Vector2f(graphics.windowSize.x * 0.33, 70), 24, "Arrow keys: Fly plane")
	--graphics:RenderTextCentered(Color(1,1,0,1), Vector2f(graphics.windowSize.x * 0.66, 70), 24, "R: Reset")
	graphics:RenderText(Color(1,1,0,1), Vector2f(graphics.windowSize.x * 0.5 - 130, 40), 24, "Hold H for help")
	if(graphics:GetKeyDown('h')) then RenderHelp() end
	--]]--
end

game:AddRenderCallback("RenderPlane")

lastTicks = 0
autoSet = false

function UpdatePlane()
	--if(player.position.z > -79.12 and autoSet == false) then
	if(player.position:Distance(Vector3f(0,0,0)) < 80 and autoSet == false) then
		SetInPlane(false)
		autoSet = true
	end
	frames = frames + 1
	ticks = SDL_GetTicks()
	if(ticks > lastTicks + 1000) then
		fps = (frames - lastFrames) / ((ticks - lastTicks) / 1000.0)
		lastTicks = ticks
		lastFrames = frames
		SDL_WM_SetCaption("RealMatter - " .. fps .. " fps", nil)
	end

	-- Setting weapon
	if(graphics:GetKeyPressed('1')) then
		weapon = 1
	elseif(graphics:GetKeyPressed('2')) then
		weapon = 2
	elseif(graphics:GetKeyPressed('3')) then
		weapon = 3
	end

	-- Firing weapon
	if(weapon == 1) then
		if(graphics:GetMousePressed(0)) then
			player:FireCannon()
		end
		if(graphics:GetMousePressed(2)) then
			player:FireGoldenCannon()
		end
	elseif(weapon == 2) then
		if(graphics:GetMouseDown(0)) then
			player:FireRayGun()
		end
		if(graphics:GetMousePressed(2)) then
			--player:FirePicker()
		end
	elseif(weapon == 3) then
		if(graphics:GetMousePressed(0)) then
			player:PlaceBomb()
		end
		if(graphics:GetMousePressed(2)) then
			player:TriggerBombs()
		end
	end

	-- Miscellaneous controls
	if(graphics:GetKeyPressed("F5")) then
		if(game.renderMode == Game.CELLS) then
			game.renderMode = Game.PARTICLES
		elseif(game.renderMode == Game.PARTICLES) then
			game.renderMode = Game.MESH
		elseif(game.renderMode == Game.MESH) then
			game.renderMode = Game.CELLS
		end
	end
	if(graphics:GetKeyPressed("F6")) then
		player.inputShouldBeGrabbed = not player.inputShouldBeGrabbed
		player.mouselook = player.inputShouldBeGrabbed
	end
	if(graphics:GetKeyPressed("F8")) then
		player.canFly = not player.canFly
	end
	if(graphics:GetKeyPressed("F7")) then
		plane.showRegions = not plane.showRegions
	end
	if(graphics:GetKeyPressed("F9")) then
		game.collisionsEnabled = not game.collisionsEnabled;
	end
	if(graphics:GetKeyPressed("F10")) then
		game.allowSelfCollision = not game.allowSelfCollision;
	end
	if(graphics:GetKeyPressed('r')) then
		game:Reset()
		SetInPlane(true)
		plane:SetThrottle(1)
		player:SetAngle(-0.15, 0)
		autoSet = false
		game:FindObject("f4u").body:AddVelocity(Vector3f(0, 0, 80))
		game:FindObject("f4u").body:Rotate(Vector3f(1,0,0), -0.23)
	end
	if(graphics:GetKeyPressed('f')) then
		SetInPlane(not inPlane)
	end
	if(graphics:GetKeyPressed("p")) then
		game.paused = not game.paused
	end
	if(graphics:GetKeyPressed("j")) then
		recording = not recording
		screenshotNo = 0
	end
	if(graphics:GetKeyPressed("F1")) then
		game:Clear()
		runScript("towerDemo.lua")
	end
end

function PrintPlayer()
	print ("X: " .. player.position.x .. ", Y: " .. player.position.y .. ", Z: " .. player.position.z)
	print ("X angle: " .. player.xAngle .. ", Y angle: " .. player.yAngle)
end

--game:SetupCannon(Vector3f(0,1.25,31), 10, 0.8, 1.0, 2.5)
game:AddUpdateCallback("UpdatePlane")


game:SetSplashScreen("")
console:SetMode(FTGLConsole.CONSOLE_CLOSED)

--player.mouselook = true
--player.inputShouldBeGrabbed = true

player.inputShouldBeGrabbed = true
player.mouselook = true
player.canFly = true
SetInPlane(true)
plane:SetThrottle(1)
